package jp.hishidama.robot.win;

import java.util.List;

import jp.hishidama.win32.JWnd;
import jp.hishidama.win32.api.WinUserConst;

/**
 * Windows_CAO.
 * <p>
 * MS-Windows̃_CAONXB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @since 2007.11.01
 */
public abstract class WindowsDialog implements WinUserConst {

	/**
	 * w莞ԑҋ@.
	 * 
	 * @param time
	 *            EFCg[~b]
	 */
	public void delay(int time) {
		if (time <= 0)
			return;
		try {
			Thread.sleep(time);
		} catch (InterruptedException e) {
		}
	}

	protected JWnd wnd;

	/**
	 * RXgN^[
	 * 
	 * @param wnd
	 *            _CAÕEBhEnh
	 */
	public WindowsDialog(JWnd wnd) {
		this.wnd = wnd;
	}

	/**
	 * _CAÕEBhEnh擾.
	 * 
	 * @return JWnd
	 */
	public JWnd getWnd() {
		return wnd;
	}

	/**
	 * EBhEݔf.
	 * 
	 * @return _CAOƂėLȏꍇAtrue
	 */
	public boolean isWindow() {
		return wnd.isWindow();
	}

	/**
	 * őOʈړ.
	 * 
	 * @return ꍇAtrue
	 */
	public boolean SetForegroundWindow() {
		try {
			return wnd.SetForegroundWindow();
		} catch (RuntimeException e) {
			return false;
		}
	}

	/**
	 * tH[JXݒ.
	 */
	public void setFocus() {
		try {
			wnd.SetFocus();
		} catch (RuntimeException e) {
		}
	}

	protected boolean init = false;

	/**
	 * Rg[.
	 * <p>
	 * qEBhEiRg[j擾ׂɌĂԁB<br>
	 * xĂ΂Ăŏ̈xȂB
	 * </p>
	 * 
	 * @see #doInit(jp.hishidama.robot.win.WindowsDialog.InitData)
	 */
	protected void init() {
		if (!init) {
			try {
				InitData ini = new InitData(wnd);
				while (ini.hasData()) {
					doInit(ini);
					ini.next();
				}
			} catch (RuntimeException e) {
			}
			init = true;
		}
	}

	/**
	 * Rg[{.
	 * <p>
	 * {@link #init()}_CAO̎qEBhEiRg[jɌĂ΂B<br>
	 * TuNXœ\bhAKvȃRg[̕ێsB
	 * </p>
	 * 
	 * @param ini
	 *            ΏۃRg[
	 * @see #init()
	 */
	protected abstract void doInit(InitData ini);

	protected class InitData {
		/** qEBhEi{@link JWnd}j̃Xg */
		public List list;

		/** {@link #list}݂̌̏ʒu */
		public int i;

		/** ݂̎qEBhẼEBhEnh */
		public JWnd wnd;

		/** ݂̎qEBhẼEBhENX */
		public String name;

		/** ݂̎qEBhẼeLXgi^Cgj */
		public String text;

		protected int size;

		/**
		 * RXgN^[.
		 * 
		 * @param dlg
		 *            _CAÕEBhEnh
		 */
		public InitData(JWnd dlg) {
			list = dlg.enumChildWindows();
			size = list.size();
			i = -1;
			next();
		}

		/**
		 * ̎qEBhEֈړ.
		 */
		public void next() {
			if (++i >= size) {
				wnd = null;
				name = null;
				text = null;
			} else {
				wnd = (JWnd) list.get(i);
				name = wnd.getClassName();
				text = wnd.GetWindowText();
			}
		}

		/**
		 * ΏۗL擾.
		 * 
		 * @return ΏۂێĂꍇAtrue
		 */
		public boolean hasData() {
			return wnd != null;
		}

		/**
		 * xf.
		 * 
		 * @return EBhENXStatic̏ꍇAtrue
		 */
		public boolean isStatic() {
			return "Static".equals(name);
		}

		/**
		 * GfBbg{bNXf.
		 * 
		 * @return EBhENXEdit̏ꍇAtrue
		 */
		public boolean isEdit() {
			return "Edit".equals(name);
		}

		/**
		 * {^f.
		 * 
		 * @return EBhENXButton̏ꍇAtrue
		 */
		public boolean isButton() {
			return "Button".equals(name);
		}

		/**
		 * eLXgf.
		 * 
		 * @param prefix
		 *            eLXg̐擪
		 * @return eLXgw肳ꂽŎn܂ĂꍇAtrue
		 */
		public boolean textStartsWith(String prefix) {
			return text != null && text.startsWith(prefix);
		}

		/**
		 * Rg[IDf.
		 * 
		 * @param id
		 *            Rg[ID
		 * @return ݂̎qEBhẼRg[w肳ꂽ̂łꍇAtrue
		 */
		public boolean isDlgCtrl(int id) {
			return wnd != null && (wnd.GetDlgCtrlID() == id);
		}
	}

	/**
	 * fobOpqEBhEꗗ\.
	 */
	protected void listID() {
		List list = wnd.enumChildWindows();
		for (int i = 0; i < list.size(); i++) {
			JWnd w = (JWnd) list.get(i);
			int id = w.GetDlgCtrlID();
			System.out.println(Long.toHexString(w.GetSafeHwnd()) + ":"
					+ Integer.toHexString(id) + "(" + id + ")" + ":"
					+ w.getClassName() + "/" + w.GetWindowText());
		}
	}

	/**
	 * GfBbg{bNX擾.
	 * 
	 * @param edit
	 *            GfBbg{bNX
	 * @return GfBbg{bNX̕
	 */
	protected String getEditText(JWnd edit) {
		try {
			// x return wnd.GetDlgItemText(edit.GetDlgCtrlID());
			int len = edit.SendMessage(WM_GETTEXTLENGTH, 0, 0) + 1;
			return edit.SendMessageGetString(WM_GETTEXT, len, len * 2);
		} catch (RuntimeException e) {
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * GfBbg{bNXݒ.
	 * 
	 * @param edit
	 *            GfBbg{bNX
	 * @param text
	 *            
	 * @return ꍇAtrue
	 */
	protected boolean setEditText(JWnd edit, String text) {
		try {
			// SetWindowText͕ʃvZX̃Rg[ɂ͎gȂ
			// return edit.SetWindowText(text);

			// x return wnd.SetDlgItemText(edit.GetDlgCtrlID(), text);

			edit.SendMessage(WM_SETTEXT, 0, text);

			// for (int i = 0; i < text.length(); i++) {
			// edit.SendMessage(WM_IME_CHAR, text.charAt(i), 0);
			// }
			return true;
		} catch (RuntimeException e) {
			// e.printStackTrace();
		}
		return false;
	}

	/**
	 * {^NbN.
	 * <p>
	 * i{^ID傫ꍇ́j_CAOɃtH[JXĂKvۂ̂ŁAO{@link #setFocus()}ĂłƁB
	 * </p>
	 * 
	 * @param btn
	 *            {^
	 * @return ꍇAtrue
	 */
	protected boolean click(JWnd btn) {
		try {
			// ȉ3ނ̂ǂ̕@łv
			// EBM_CLICKWM_LBUTTONDOWNWM_LBUTTONUP𔭐
			// EŏIIWM_COMMAND

			btn.PostMessage(BM_CLICK, 0, 0);

			// int x = 0, y = 0;
			// int lpos = (y << 16) | x;
			// btn.PostMessage(WM_LBUTTONDOWN, MK_LBUTTON, lpos);
			// btn.PostMessage(WM_LBUTTONUP, 0, lpos);

			// int id = btn.GetDlgCtrlID();
			// int lparam = (int) btn.GetSafeHwnd();
			// wnd.PostMessage(WM_COMMAND, (BN_CLICKED << 16) | id, lparam);

			return true;
		} catch (RuntimeException e) {
			// e.printStackTrace();
		}
		return false;
	}
}
