package jp.hishidama.win32.com;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * COMIuWFNg.
 * <p>
 * IUnkownɊYNXB<br>
 * DLL̃|C^[ێĂ̂ŁANXpCX^Xł́AgIKdispose()ĂяoĉiŎQƃJE^[炷jKvB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @since 2007.10.22
 */
public class ComPtr {
	/**
	 * DLLŊmۂ|C^[
	 */
	private long ptr;

	private boolean enable = true;

	static ComPtr top;

	ComPtr next, prev;

	protected List child;

	protected ComPtr(long dll_ptr) {
		ptr = dll_ptr;

		if (top != null) {
			this.next = top;
			top.prev = this;
		}
		top = this;
	}

	protected long getPtr() {
		if (!enable) {
			throw new ComException("already disposed.");
		}
		return ptr;
	}

	/**
	 * CX^Xj.
	 * <p>
	 * YCX^XjB<br>
	 * iDLL̎QƃJE^[ׁAKŌɓ\bhĂԕKvj
	 * </p>
	 */
	public void dispose() {
		try {
			if (enable) {
				if (prev == null) {
					top = this.next;
				} else {
					prev.next = this.next;
				}
				if (next != null) {
					next.prev = this.prev;
				}
				try {
					ComMgr.delete(ptr);
				} finally {
					ptr = 0;
				}
			}
		} finally {
			enable = false;
			next = null;
			prev = null;
		}
	}

	/**
	 * qIuWFNgǉ.
	 * <p>
	 * IuWFNggAĔjΏہhɉB
	 * </p>
	 * 
	 * @param c
	 *            qIuWFNg
	 * @see #disposeChild()
	 */
	protected void addChildComPtr(ComPtr c) {
		if (child == null) {
			child = new LinkedList();
		}
		child.add(c);
	}

	/**
	 * qIuWFNgj.
	 * <p>
	 * IuWFNg擾IuWFNgSĔjB<br>
	 * 擾ɈaddChildtruew肵ĂIuWFNgΏہB
	 * </p>
	 * <p>
	 * PF<br>
	 * <code>WebBrowser wb = WebBrowser.create();<br>
	 * HtmlDocument doc = wb.getDocument(<b>false</b>); //addChild=false<br>
	 * ComPtr.dispose(doc, false); //doc<br>
	 * ComPtr.dispose(wb, false);  //wbʁXɔjKv</code>
	 * </p>
	 * <p>
	 * QF<br>
	 * <code>WebBrowser wb = WebBrowser.create();<br>
	 * HtmlDocument doc = wb.getDocument(<b>true</b>); //addChild=true<br>
	 * ComPtr.dispose(wb, <b>true</b>); //ŁAdocɔj</code><br>
	 * œ\bhĂ΂ĂB
	 * </p>
	 * <p>
	 * RF<br>
	 * <code>IERobot robot = IERobot.create();<br>
	 * HtmlDocument doc = robot.getDocument();<br>
	 * HtmlElement elem = doc.getActiveElement(<b>true</b>); //addChild=true<br>
	 * robot.dispose(); //robotjelemdocj</code><br>
	 * œ\bhĂ΂ĂB
	 * </p>
	 * 
	 * @see #addChildComPtr(ComPtr)
	 */
	public void disposeChild() {
		if (child != null) {
			for (Iterator i = child.iterator(); i.hasNext();) {
				ComPtr c = (ComPtr) i.next();
				ComPtr.dispose(c, true);
			}
		}
		child = null;
	}

	/**
	 * CX^Xj.
	 * 
	 * @param c
	 *            CX^Xinull̏ꍇAj
	 * @param child
	 *            trueFqIuWFNgj
	 * @see #dispose()
	 */
	public static void dispose(ComPtr c, boolean child) {
		if (c != null) {
			if (child) {
				c.disposeChild();
			}
			c.dispose();
		}
	}

	/**
	 * XgCX^Xj.
	 * <p>
	 * Xg̑SCX^XjB
	 * </p>
	 * 
	 * @param list
	 *            ComPtr̃Xg
	 * @param child
	 *            trueFqIuWFNgj
	 * @see #dispose(List, boolean)
	 */
	public static void dispose(List list, boolean child) {
		if (list == null || list.size() <= 0)
			return;
		for (Iterator i = list.iterator(); i.hasNext();) {
			ComPtr c = (ComPtr) i.next();
			dispose(c, child);
		}
	}

	/**
	 * XgCX^Xj.
	 * <p>
	 * Xǵiw肳ꂽ̈ȊÓjSCX^XjB
	 * </p>
	 * 
	 * @param list
	 *            ComPtr̃Xg
	 * @param exclude
	 *            jȂComPtr
	 * @param child
	 *            trueFqIuWFNgj
	 * @see #dispose(ComPtr, boolean)
	 */
	public static void dispose(List list, ComPtr exclude, boolean child) {
		if (list == null || list.size() <= 0)
			return;
		for (Iterator i = list.iterator(); i.hasNext();) {
			ComPtr c = (ComPtr) i.next();
			if (c != exclude) {
				dispose(c, child);
			}
		}
	}
}
