package jp.hishidama.win32.mshtml;

import jp.hishidama.win32.com.ComPtr;
import jp.hishidama.win32.com.IDispatch;
import jp.hishidama.win32.com.IUnknown;
import jp.hishidama.win32.com.Variant;

/**
 * IHTMLWindow2`3NX.
 * <p>
 * HTMLEBhENXłB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @since 2007.10.22
 * @version 2007.11.05
 */
public class IHTMLWindow extends IHTMLFramesCollection {

	protected IHTMLWindow(long dll_ptr) {
		super(dll_ptr);
	}

	protected long getPtr() {
		return super.getPtr();
	}

	/**
	 * t[擾.
	 * 
	 * @param addChild
	 *            trueFAj
	 * @return RNV
	 * @see ComPtr#disposeChild()
	 */
	public IHTMLFramesCollection getFrames(boolean addChild) {
		IHTMLFramesCollection c = Native.get_frames(getPtr());
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	public void setDefaultStatus(String status) {
		Native.put_defaultStatus(getPtr(), status);
	}

	public String getDefaultStatus() {
		return Native.get_defaultStatus(getPtr());
	}

	public void setStatus(String status) {
		Native.put_status(getPtr(), status);
	}

	public String getStatus() {
		return Native.get_status(getPtr());
	}

	/**
	 * x_CAO\.
	 * 
	 * @param message
	 *            bZ[W
	 */
	public void alert(String message) {
		Native.alert(getPtr(), message);
	}

	/**
	 * mF_CAO\.
	 * 
	 * @param message
	 *            bZ[W.
	 * @return ߂l
	 */
	public boolean confirm(String message) {
		return Native.confirm(getPtr(), message);
	}

	/**
	 * ̓_CAO\.
	 * 
	 * @param message
	 *            bZ[W.
	 * @param defstr
	 *            l
	 * @return ͒l
	 */
	public Variant prompt(String message, String defstr) {
		return Native.prompt(getPtr(), message, defstr);
	}

	public IHTMLLocation getLocation(boolean addChild) {
		IHTMLLocation c = Native.get_location(getPtr());
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	public void close() {
		Native.close(getPtr());
	}

	public void setOpener(Variant opener) {
		Native.put_opener(getPtr(), opener);
	}

	public Variant getOpener() {
		return Native.get_opener(getPtr());
	}

	public void setName(String name) {
		Native.put_name(getPtr(), name);
	}

	public String getName() {
		return Native.get_name(getPtr());
	}

	/**
	 * eEBhE擾.
	 * 
	 * @param addChild
	 *            trueFAj
	 * @return HTMLEBhE
	 * @see ComPtr#disposeChild()
	 */
	public IHTMLWindow getParent(boolean addChild) {
		IHTMLWindow w = Native.get_parent(getPtr());
		if (addChild) {
			addChildComPtr(w);
		}
		return w;
	}

	public IHTMLWindow open(String url, String name, String features,
			boolean replace, boolean addChild) {
		IHTMLWindow w = Native.open(getPtr(), url, name, features, replace);
		if (addChild) {
			addChildComPtr(w);
		}
		return w;
	}

	public IHTMLWindow getSelf(boolean addChild) {
		IHTMLWindow w = Native.get_self(getPtr());
		if (addChild) {
			addChildComPtr(w);
		}
		return w;
	}

	public IHTMLWindow getTop(boolean addChild) {
		IHTMLWindow w = Native.get_top(getPtr());
		if (addChild) {
			addChildComPtr(w);
		}
		return w;
	}

	public IHTMLWindow getWindow(boolean addChild) {
		IHTMLWindow w = Native.get_window(getPtr());
		if (addChild) {
			addChildComPtr(w);
		}
		return w;
	}

	public void navigate(String url) {
		Native.navigate(getPtr(), url);
	}

	/**
	 * HTMLhLg擾.
	 * 
	 * @param addChild
	 *            trueFAj
	 * @return HTMLhLg
	 * @see ComPtr#disposeChild()
	 */
	public IHTMLDocument getDocument(boolean addChild) {
		IHTMLDocument d = Native.get_document(getPtr());
		if (addChild) {
			addChildComPtr(d);
		}
		return d;
	}

	public IUnknown getNewEnum(boolean addChild) {
		IUnknown c = Native.get__newEnum(getPtr());
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	/**
	 * tH[JXݒ.
	 */
	public void focus() {
		Native.focus(getPtr());
	}

	public boolean isClosed() {
		return Native.get_closed(getPtr());
	}

	public void blur() {
		Native.blur(getPtr());
	}

	public void scroll(int x, int y) {
		Native.scroll(getPtr(), x, y);
	}

	public Variant execScript(String code, String language) {
		return Native.execScript(getPtr(), code, language);
	}

	public void scrollBy(int x, int y) {
		Native.scrollBy(getPtr(), x, y);
	}

	public void scrollTo(int x, int y) {
		Native.scrollTo(getPtr(), x, y);
	}

	public void moveTo(int x, int y) {
		Native.moveTo(getPtr(), x, y);
	}

	public void moveBy(int x, int y) {
		Native.moveBy(getPtr(), x, y);
	}

	public void resizeTo(int x, int y) {
		Native.resizeTo(getPtr(), x, y);
	}

	public void resizeBy(int x, int y) {
		Native.resizeBy(getPtr(), x, y);
	}

	public IDispatch getExternal(boolean addChild) {
		IDispatch c = Native.get_external(getPtr());
		if (addChild) {
			addChildComPtr(c);
		}
		return c;
	}

	public int getScreenLeft() {
		return Native.get_screenLeft(getPtr());
	}

	public int getScreenTop() {
		return Native.get_screenTop(getPtr());
	}

	public void print() {
		Native.print(getPtr());
	}

	private static class Native {
		//
		// IHTMLWindow2
		//
		private static native IHTMLFramesCollection get_frames(long ptr);

		private static native void put_defaultStatus(long ptr, String p);

		private static native String get_defaultStatus(long ptr);

		private static native void put_status(long ptr, String p);

		private static native String get_status(long ptr);

		// private static native void setTimeout (long ptr);
		// private static native void clearTimeout (long ptr);

		private static native void alert(long ptr, String message);

		private static native boolean confirm(long ptr, String message);

		private static native Variant prompt(long ptr, String message,
				String defstr);

		// private static native IHTMLImageElementFactory get_Image (long ptr);

		private static native IHTMLLocation get_location(long ptr);

		// private static native IOmHistory get_history (long ptr);

		private static native void close(long ptr);

		private static native void put_opener(long ptr, Variant p);

		private static native Variant get_opener(long ptr);

		// / private static native IOmNavigator get_navigator (long ptr);

		private static native void put_name(long ptr, String p);

		private static native String get_name(long ptr);

		private static native IHTMLWindow get_parent(long ptr);

		private static native IHTMLWindow open(long ptr, String url,
				String name, String features, boolean replace);

		private static native IHTMLWindow get_self(long ptr);

		private static native IHTMLWindow get_top(long ptr);

		private static native IHTMLWindow get_window(long ptr);

		private static native void navigate(long ptr, String url);

		private static native IHTMLDocument get_document(long ptr);

		// private static native IHTMLEventObj get_event (long ptr);

		private static native IUnknown get__newEnum(long ptr);

		// private static native Variant showModalDialog(long ptr, String
		// dialog,
		// Variant[] varArgIn, Variant[] varOptions);

		// private static native void showHelp(long ptr, String helpURL,
		// Variant helpArg, String features);

		// private static native IHTMLScreen get_screen (long ptr);
		// private static native IHTMLOptionElementFactory get_Option (long
		// ptr);

		private static native void focus(long ptr);

		private static native boolean get_closed(long ptr);

		private static native void blur(long ptr);

		private static native void scroll(long ptr, int x, int y);

		// private static native IOmNavigator get_clientInformation (long ptr);
		// private static native void setInterval (long ptr);
		// private static native void clearInterval (long ptr, int timerID );
		// private static native void put_offscreenBuffering (long ptr, VARIANT
		// p );
		// private static native VARIANT get_offscreenBuffering (long ptr);

		private static native Variant execScript(long ptr, String code,
				String language);

		// private static native String toString (long ptr);

		private static native void scrollBy(long ptr, int x, int y);

		private static native void scrollTo(long ptr, int x, int y);

		private static native void moveTo(long ptr, int x, int y);

		private static native void moveBy(long ptr, int x, int y);

		private static native void resizeTo(long ptr, int x, int y);

		private static native void resizeBy(long ptr, int x, int y);

		private static native IDispatch get_external(long ptr);

		//
		// IHTMLWindow3
		//
		private static native int get_screenLeft(long ptr);

		private static native int get_screenTop(long ptr);

		// private static native void attachEvent (long ptr);
		// private static native void detachEvent (long ptr);
		// private static native void setTimeout (long ptr);
		// private static native void setInterval (long ptr);

		private static native void print(long ptr);

		// private static native IHTMLDataTransfer get_clipboardData (long ptr);
		// private static native IHTMLWindow showModelessDialog(long ptr,
		// String url, Variant[] varArgIn, Variant[] options);

		//
		// IHTMLWindow4
		//
		// private static native HtmlFrameBase get_frameElement(long ptr);

	}
}
